/**
 * Copyright (c) Facebook, Inc. and its affiliates.
 *
 * This source code is licensed under the MIT license found in the
 * LICENSE file in the root directory of this source tree.
 *
 * 
 * @format
 * @emails oncall+relay
 */
'use strict';

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { (0, _defineProperty2["default"])(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

var IRTransformer = require('../core/IRTransformer');

var _require = require('relay-runtime'),
    RelayFeatureFlags = _require.RelayFeatureFlags;

var FLIGHT_FIELD_SCALAR_NAME = 'ReactFlightComponent';
/**
 * Experimental transform for React Flight.
 */

function reactFlightComponentTransform(context) {
  return IRTransformer.transform(context, {
    ScalarField: visitScalarField
  });
}

function visitScalarField(field) {
  var transformedField = this.traverse(field);

  if (RelayFeatureFlags.ENABLE_REACT_FLIGHT_COMPONENT_FIELD === false || transformedField.type.name !== FLIGHT_FIELD_SCALAR_NAME) {
    return transformedField;
  }

  return _objectSpread({}, transformedField, {
    metadata: _objectSpread({}, transformedField.metadata || {}, {
      flight: true
    })
  });
}

module.exports = {
  transform: reactFlightComponentTransform
};